function component(_gadget)
{
	this.mFileTransferObj;
	this.mCurrentStateData;
	this.mFileNumBytesPerPBar;
	this.mFilesNumBytesPerPBar;
	this.mTotalNumFilesRemain;
	this.mCurrFileProgressBar = 0;
	this.mCurrFilesProgressBar = 0;
	this.mElapsedHndl;
	this.mTimeElapsed=0;
	this.mElements;
	this.mTimerObj = shell.serviceManager.basics.timer;
	this.mNumFiles = 0;
	this.mTotalBytes=0;
		
}

function fileTransferObj(htmlElement,blockID,XferSession,ResourcePath)
{
	this.mHtmlElement = htmlElement;
	this.mBlockId = blockID;
	this.mSessionObj = XferSession;
	this.mImgResPath = ResourcePath;
}

component.prototype.Init = function(htmlElement,blockID,XferSession,ResourcePath)
{
	//init the object with all the necessary data
	this.mFileTransferObj = new fileTransferObj(htmlElement,blockID,XferSession,ResourcePath);
	this.mNumFiles = this.mFileTransferObj.mSessionObj.TotalNumFiles;
	this.mTotalBytes =	this.mFileTransferObj.mSessionObj.TotalBytes;
	
	var dateOld  = new Date(this.mFileTransferObj.mSessionObj.OnlineSinceTime);
	var now  = new Date();
	if(dateOld.getYear() != 1899)
	{
		this.mTimeElapsed = Math.floor((now.getTime() - dateOld.getTime())/1000);
	}
 
}

component.prototype.OnDestroyed = function()
{
	if (this.mTimerObj)
	{
		this.mTimerObj.cancel();
		this.mTimerObj = null;
	}
}

component.prototype.SetState = function(stateName,stateData)
{
	this.mCurrentStateData = stateData;
	switch(stateName)
	{
		case "BeforeSend":
		case "BeforeReceive":
			this.mFilesNumBytesPerPBar = Math.floor(this.mFileTransferObj.mSessionObj.TotalBytes/14);
			var name = this.mFileTransferObj.mSessionObj.Name; //this.mFileTransferObj.mSessionObj.CurrentFileXfer.Name;
			var size = this.getFileSizeText(this.mFileTransferObj.mSessionObj.TotalBytes,stateData);
			if(this.mFileTransferObj.mSessionObj.TotalNumFiles > 1)
				name = stateData.TotalText;
			var oDiv=this.mFileTransferObj.mHtmlElement;
			var dir = oDiv.document.body.dir;
			oDiv.id=this.mFileTransferObj.mBlockId;
			oDiv.className = 'd';
			oDiv.onselectstart = function(){return false;}// disable selectection text
			oDiv.ondragstart   = function(){return false;}// disable drag & drop text
			
			var image_path = stateData.IconPath;
			if(image_path == '')
			{	 	// check if get image path from client
				if(this.mFileTransferObj.mSessionObj.Send==true)
				{ 	// check if this process is Send OR Reaceive
					image_path = this.mFileTransferObj.mImgResPath+'/IMAGES/Common/IcqDhtmlObjects/FileXfer/send_multi.gif';
				}
				else
				{
					image_path = this.mFileTransferObj.mImgResPath+'/IMAGES/Common/IcqDhtmlObjects/FileXfer/rec_multi.gif';
				}
			}
			
			html_str  ='<table class="d-tbl"><tr>';
				html_str  +='<td class="d-tbl-1">';
					html_str  +='<div class="d-1">';
						html_str  +='<img id="iconPath_'+this.mFileTransferObj.mBlockId + '" src="'+image_path+'" border="0" width="32" height="32">';	
					html_str  +='</div>'; 
				html_str  +='</td>';
				html_str  +='<td class="d-tbl-2">';
				
				html_str  +='<div class="d-2" id="upperSection_'+this.mFileTransferObj.mBlockId+'" >';
				html_str  +='<div class="d-2-1" id="titleText_'+this.mFileTransferObj.mBlockId+'">'+stateData.TitleText+'</div>';
				
				html_str  +='<div class="d-2-2">';
					html_str  +='<table id="mainTbl" class="d-tbl_info">';
						html_str  +='<tr>';
							html_str  +='<td nowrap class="d-2-2-file">';
								html_str  +='<span id="fileName_'+this.mFileTransferObj.mBlockId+'">'+name+'</span>';
							html_str  +='</td>';
							
							html_str  +='<td nowrap width="80">';
								html_str  +='<span class="d-2-2-size" id="fileSizeText_'+this.mFileTransferObj.mBlockId+'">('+size+')</span>';
							html_str  +='</td>';
							
						html_str  +='</tr>';
					html_str  +='</table>';
				html_str  +='</div>';
				
				
				html_str  +='<div class="d-2-2-links"><span class="d-2-4" id="totalFiles_'+this.mFileTransferObj.mBlockId+'"></span>';
				html_str  +='<span id="actions_'+this.mFileTransferObj.mBlockId+'">';
				
				var nActions = stateData.Actions.Count;
				var Action;
				for(var i=0;i<nActions;i++)
				{
					Action = stateData.Actions.Item(i);
					html_str += '<a class="d-2-link" href="'+Action.ActionURL+'">'+Action.ActionText+'</a>';
					if (Action.ActionShortcutText != '')
						html_str += '&nbsp;('+Action.ActionShortcutText+')';
					html_str += '&nbsp;&nbsp;';
				}
				
				if (nActions < 1)
				{
					// we need to create placeholder for actions in case there are no actions given in initial state
					html_str += '<a class="d-2-link"></a>';
				}
				
				html_str  +='</span></div>';
				html_str  +='</div>';
				html_str  +='</td>';
				
				
				html_str  +='<td  class="d-tbl-3">';

				html_str += '<div class="d-3" id="fileTransfer_'+this.mFileTransferObj.mBlockId+'">';
				html_str += '<div class="d-3-1"><div class="d-3-1-1"><img src="'+this.mFileTransferObj.mImgResPath+'/IMAGES/Common/IcqDhtmlObjects/FileXfer/file-transfer-elapsed.png"></div><div class="d-3-1-2"><span id="elapsedTime_'+this.mFileTransferObj.mBlockId+'">00:00:00</span></div><div class="d-3-1-3"><img src="'+this.mFileTransferObj.mImgResPath+'/IMAGES/Common/IcqDhtmlObjects/FileXfer/file-transfer-remain.png"></div><div class="d-3-1-4"><span id="remainingTime_'+this.mFileTransferObj.mBlockId+'">00:00:00</span></div></div>';
				html_str += '<div class="d-3-2">';
				html_str += '<div class="d-3-2-1" id="d-3-2-1"><span id="fileTransferedSize_'+this.mFileTransferObj.mBlockId+'">0'+stateData.BytesText+'</span></div>';
				html_str += '<div class="d-3-2-2" id="d-3-2-2" style="background-image: url('+this.mFileTransferObj.mImgResPath+'/IMAGES/Common/IcqDhtmlObjects/FileXfer/progress-bar.gif);">';
				html_str += '<div class="d-3-2-2-1" id="progressBar_'+this.mFileTransferObj.mBlockId+'"></div>';
				html_str += '</div></div>';
				if(this.mFileTransferObj.mSessionObj.TotalNumFiles > 1)
				{
					html_str  +='<div class="d-3-3">';
					html_str  +='<div class="d-3-3-1" id="filesTransferedSize_'+this.mFileTransferObj.mBlockId+'">0'+stateData.BytesText+'</div>';
					html_str  +='<div class="d-3-3-2" style="background-image: url('+this.mFileTransferObj.mImgResPath+'/IMAGES/Common/IcqDhtmlObjects/FileXfer/progress-bar.gif);">';
					html_str  +='<div class="d-3-3-2-1" id="totalProgreesBar_'+this.mFileTransferObj.mBlockId+'"></div>';
					html_str  +='</div></div>';
				}
				html_str += '</div>';
				html_str  +='</td></tr></table>';
				
				
				
				html_str += '<div class="';
					if(dir == "rtl")
						html_str += '.d-4-r">';
					else
						html_str += 'd-4">';
				
					html_str += '<div class="d-4-2" id="statusIcon_'+this.mFileTransferObj.mBlockId+'">';
					html_str += '<img src="'+this.mFileTransferObj.mImgResPath+'/IMAGES/Common/IcqDhtmlObjects/FileXfer/waiting.gif" border="0" width="16" height="16" >&nbsp;';
					html_str += '</div>';
					html_str += '<div class="d-4-1" id="statusText_'+this.mFileTransferObj.mBlockId+'">'+stateData.StatusText+'</div><div class="d-4-3" id="statusSpeed_'+this.mFileTransferObj.mBlockId+'">&nbsp;</div>';
				html_str += '</div>';
			
			
				
				
			this.mElements = new Object();
			this.mElements['DivShow'] = oDiv;
			this.mElements['DivShow'].innerHTML+= html_str;

			var elementDoc = oDiv.document;
			
			this.mElements['iconPath'] = elementDoc.getElementById('iconPath_'+this.mFileTransferObj.mBlockId);
			this.mElements['upperSection'] = elementDoc.getElementById('upperSection_'+this.mFileTransferObj.mBlockId);
			this.mElements['titleText'] = elementDoc.getElementById('titleText_'+this.mFileTransferObj.mBlockId);
			this.mElements['fileName'] = elementDoc.getElementById('fileName_'+this.mFileTransferObj.mBlockId);
			this.mElements['fileSizeText'] = elementDoc.getElementById('fileSizeText_'+this.mFileTransferObj.mBlockId);
			this.mElements['totalFiles'] = elementDoc.getElementById('totalFiles_'+this.mFileTransferObj.mBlockId);
			this.mElements['fileTransferedSize'] = elementDoc.getElementById('fileTransferedSize_'+this.mFileTransferObj.mBlockId);
			this.mElements['actions'] = elementDoc.getElementById('actions_'+this.mFileTransferObj.mBlockId);
			this.mElements['fileTransfer'] = elementDoc.getElementById('fileTransfer_'+this.mFileTransferObj.mBlockId);
			this.mElements['elapsedTime'] = elementDoc.getElementById('elapsedTime_'+this.mFileTransferObj.mBlockId);
			this.mElements['remainingTime'] = elementDoc.getElementById('remainingTime_'+this.mFileTransferObj.mBlockId);
			this.mElements['progressBar'] = elementDoc.getElementById('progressBar_'+this.mFileTransferObj.mBlockId);
			this.mElements['filesTransferedSize'] = elementDoc.getElementById('filesTransferedSize_'+this.mFileTransferObj.mBlockId);
			this.mElements['totalProgreesBar'] = elementDoc.getElementById('totalProgreesBar_'+this.mFileTransferObj.mBlockId);
			this.mElements['statusIcon'] = elementDoc.getElementById('statusIcon_'+this.mFileTransferObj.mBlockId);
			this.mElements['statusText'] = elementDoc.getElementById('statusText_'+this.mFileTransferObj.mBlockId);
			this.mElements['statusSpeed'] = elementDoc.getElementById('statusSpeed_'+this.mFileTransferObj.mBlockId);
			
			//reformat the file name
			this.reFormatFileName(this.mElements['fileName']);
			this.setElapsedTime();
		break;
		
		case "ConnectingReceive":
		case "ConnectingSend":
			this.mElements['titleText'].innerHTML = stateData.TitleText;
			this.mElements['titleText'].style.color='';
			this.mElements['fileSizeText'].style.color='';
			this.mElements['fileName'].style.color='';
			this.mElements['statusSpeed'] .style.display='none';
			this.mElements['statusText'].innerHTML = stateData.StatusText;
			break;
		case "Receiving":
		case "Sending":
			this.mFileNumBytesPerPBar = Math.floor(this.mFileTransferObj.mSessionObj.CurrentFileXfer.Bytes/14); // CurrentFileXfer.Bytes
			this.mElements['fileTransfer'].style.display = 'block';
			this.mElements['titleText'].innerHTML = stateData.TitleText;
			if(this.mFileTransferObj.mSessionObj.TotalNumFiles > 1)
			{
				this.mElements['totalFiles'].innerHTML = stateData.TotalText+' ('+this.getFileSizeText(this.mFileTransferObj.mSessionObj.TotalBytes,stateData)+')<br />';
			}
			// icon for each file can be different
			if (stateData.IconPath != '') 
			{
				this.mElements['iconPath'].outerHTML = '<img id="iconPath_'+this.mFileTransferObj.mBlockId+'" src="'+stateData.IconPath+'" border="0" width="32" height="32">';
			}
			this.mElements['statusSpeed'] .style.display='inline';
			this.mElements['statusText'].innerHTML = stateData.StatusText;
			this.mElements['statusSpeed'].innerHTML = '&nbsp;0'+stateData.BytesText;
			this.mTimerObj.setForOffset(this,"setElapsedTime",1000);
			break;
		case 'Failed':
			this.mElements['titleText'].style.color='red';
			this.mElements['fileSizeText'].style.color='red';
			this.mElements['fileName'].style.color='red';
			
		case 'Done':
		case 'Canceled':
			this.mTimerObj.cancel();
			this.mElements['titleText'].innerHTML = stateData.TitleText;
			this.mElements['fileTransfer'].style.display = 'none';
			this.mElements['statusSpeed'] .style.display='none';
			if(stateName == 'Done')
				this.mElements['statusIcon'].innerHTML = '<img src="'+this.mFileTransferObj.mImgResPath+'/IMAGES/Common/IcqDhtmlObjects/FileXfer/done.gif" border="0" width="16" height="16" >';
			else
				this.mElements['statusIcon'].innerHTML = '<img src="'+this.mFileTransferObj.mImgResPath+'/IMAGES/Common/IcqDhtmlObjects/FileXfer/failed-cancel.gif" border="0" width="16" height="16" >';

			this.mElements['statusText'].innerHTML = stateData.StatusText;

			if(this.mNumFiles > 1)
			{
				this.mElements['fileSizeText'].innerHTML = '&nbsp;('+this.getFileSizeText(this.mTotalBytes,stateData)+')';
				this.mElements['totalFiles'].innerHTML = '';
				this.mElements['fileName'].innerHTML = stateData.TotalText;
				this.mElements['fileName'].className='d-2-2-file';
			}
			else
			{
				// File name could be updated if there was a collision
				this.mElements['fileName'].innerHTML = this.mFileTransferObj.mSessionObj.Name;
			}
			
			break;
		
	}

	// actions are for all states except for the very first one
	if (stateName != 'beforeSend')
	{
		if (stateName != 'beforeReceive')
		{
			var html_str = '';
			var nActions = this.mCurrentStateData.Actions.Count;
			var Action;
			for(var i=0; i < nActions; i++)
			{
				Action = this.mCurrentStateData.Actions.Item(i);
				html_str += '<a class="d-2-link" href="'+Action.ActionURL+'">'+Action.ActionText+'</a>';
				if (Action.ActionShortcutText != '')
					html_str += '&nbsp;('+Action.ActionShortcutText+')';
				html_str += '&nbsp;&nbsp;';
			}
			this.mElements['actions'].innerHTML = html_str;
		}
	}
}

component.prototype.UpdateProgress = function()
{
//	return;

	//first check it is multiple file proccess
		if(this.mFileTransferObj.mSessionObj.TotalNumFiles > 1)
		{
			if(this.mTotalNumFilesRemain != this.mFileTransferObj.mSessionObj.TotalNumFilesRemaining)
			{
				this.mElements['fileName'].innerHTML = this.mFileTransferObj.mSessionObj.CurrentFileXfer.Name;
				this.mElements['fileSizeText'].innerHTML='&nbsp;('+this.getFileSizeText(this.mFileTransferObj.mSessionObj.CurrentFileXfer.Bytes,this.mCurrentStateData)+')';
				
				this.reFormatFileName(this.mElements['fileName']);
				this.mCurrFileProgressBar = 0;
				this.mElements['progressBar'].innerHTML='';
				this.mTotalNumFilesRemain = this.mFileTransferObj.mSessionObj.TotalNumFilesRemaining;
			}
			this.mElements['filesTransferedSize'].innerHTML = this.getFileSizeText(this.mFileTransferObj.mSessionObj.TotalBytesXferred,this.mCurrentStateData);
			var numBarsNeeded = Math.floor(this.mFileTransferObj.mSessionObj.TotalBytesXferred/this.mFilesNumBytesPerPBar);
			var html = '';
			for(;this.mCurrFilesProgressBar<numBarsNeeded;this.mCurrFilesProgressBar++)
			{
					html += '<img src="'+this.mFileTransferObj.mImgResPath+'/IMAGES/Common/IcqDhtmlObjects/FileXfer/progress-bar-adv.gif" border="0" width="10" height="10">';
			}
			if(html != '')
				this.mElements['totalProgreesBar'].innerHTML += html;
		}
		
		//first get the current file transfered size
		this.mElements['fileTransferedSize'].innerHTML = this.getFileSizeText(this.mFileTransferObj.mSessionObj.CurrentFileXfer.BytesXferred,this.mCurrentStateData);
		var html = '';
		if(this.mFileNumBytesPerPBar != 0)
		{
			var numBarsNeeded = Math.floor(this.mFileTransferObj.mSessionObj.CurrentFileXfer.BytesXferred/this.mFileNumBytesPerPBar);
		}
			else
			{
				var numBarsNeeded = 1;
			}
		for(;this.mCurrFileProgressBar<numBarsNeeded;this.mCurrFileProgressBar++)
		{
				html += '<img src="'+this.mFileTransferObj.mImgResPath+'/IMAGES/Common/IcqDhtmlObjects/FileXfer/progress-bar-adv.gif" border="0" width="10" height="10">';
		}
		if(html != '')
			this.mElements['progressBar'].innerHTML += html;
		this.mElements['statusSpeed'].innerHTML = '&nbsp;'+this.getSpeedSizeText(this.mFileTransferObj.mSessionObj.Speed,this.mCurrentStateData);
		//calculate the remain time
		var speed	=	this.mFileTransferObj.mSessionObj.Speed;
		if(speed	==	0)
			speed	=	1;
			
		var remain = Math.round((this.mFileTransferObj.mSessionObj.TotalBytes - this.mFileTransferObj.mSessionObj.TotalBytesXferred)/speed);
		this.mElements['remainingTime'].innerHTML = this.getFormatedTime(remain);
}

component.prototype.setElapsedTime = function()
{  // debugger;
	var html = this.getFormatedTime(this.mTimeElapsed);
	this.mElements['elapsedTime'].innerHTML = html;
	this.mTimeElapsed++;
	this.mTimerObj.setForOffset(this,"setElapsedTime",1000);
	if(html == '99:59:59')
		this.mTimerObj.cancel(); 
}

component.prototype.getFormatedTime = function(seconds)
{
		var hour = 0;
		var min = 0;
		
		if(seconds >= 3600)
		{
			hour = Math.floor(seconds/3600);
			seconds -= (hour*3600);
			if(hour > 99)
				hour = 99;
		}
		if(seconds >=60)
		{
			min = Math.floor(seconds/60);
			seconds -= (min*60);
	
		}

		if(hour < 10)
				hour = '0'+hour;
		if(min < 10)
				min = '0'+min;		
		if(seconds < 10)
				seconds = '0'+seconds;
	 
		return hour+':'+min+':'+seconds;
}

component.prototype.getFileSizeText = function(size,stateData)
{
		var ret = '';
		var counter;
		for(counter = 0 ;  size >= 1000 ;counter++)
		{
				size = size/1000;
		}
		
		if(counter < 2)//if more than kb then get 2 numbers after the point
			size = Math.round(size);
		else
		{
			size=Math.round(size*100)/100;
		}
		
		switch(counter)
		{
			case 0:
				ret = stateData.BytesText;
				break;
			case 1:
				ret = stateData.KbText;
				break;
			case 2:
				ret = stateData.MbText;
				break;
			case 3:
				ret = stateData.GbText;
				break;
		}
		ret = size+ret;
			
		return ret;
}

component.prototype.getSpeedSizeText = function(size,stateData)
{
		var ret = '';
		var counter;
		for(counter = 0 ;  size >= 1000 ;counter++)
		{
				size = size/1000;
		}
		
		if(counter < 2)//if more than kb then get 2 numbers after the point
			size = Math.round(size);
		else
		{
			size=Math.round(size*10)/10;
		}
		
		switch(counter)
		{
			case 0:
				ret = stateData.BytesText;
				break;
			case 1:
				ret = stateData.KbText;
				break;
			case 2:
				ret = stateData.MbText;
				break;
			case 3:
				ret = stateData.GbText;
				break;
		}
		ret = size+ret+stateData.PerSecondText;
			
		return ret;
}

component.prototype.reFormatFileName = function(elm)
{
	//debugger;
		/*if(elm.clientWidth >= 102)
				elm.className='d-2-2-file';
		else
				elm.className='d-2-2-file';
		
		elm.className='';
		elm.className='d-2-2-file';
		*/
		
		
		//this.mElements['DivShow'].document.getElementById('mainTbl').width=elm.clientWidth+80;
		
		
}
